/*
*
*         JSBeams : Numerical solution of beam structures in JavaScript       
*                                                                             
*                            version 0.7 (2013-08-20)                         
*  
*                    Copyright (C)  2011 - 2013  Jan Stransky                 
*  
*           Czech Technical University, Faculty of Civil Engineering,         
*       Department of Structural Mechanics, 166 29 Prague, Czech Republic     
*  
*  JSBeams is free software: you can redistribute it and/or modify it under
*  the terms of the GNU Lesser General Public License as published by the Free
*  Software Foundation, either version 3 of the License, or (at your option)
*  any later version.
*  
*  JSBeams is distributed in the hope that it will be useful, but WITHOUT ANY
*  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
*  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
*  more details.
*  
*  You should have received a copy of the GNU Lesser General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
var JSBeams={CLAMPED_CLAMPED:0,CC:0,CLAMPED_HINGE:1,CH:1,HINGE_CLAMPED:2,HC:2,HINGE_HINGE:3,HH:3,TRUSS:3,Node:function(a,b,c){this.x=a||0;this.y=b||0;this.z=c||0}};JSBeams.Node.prototype.toString=function(){return"Node ( "+this.x+", "+this.y+", "+this.z+" )"};JSBeams.Node.prototype.setXYZ=function(a,b,c){this.x=a;this.y=b;this.z=c};JSBeams.Node.prototype.setXZ=function(a,b){this.x=a;this.z=b};JSBeams.Node.prototype.setYZ=function(a,b){this.y=a;this.z=b};
JSBeams.Node.prototype.setX=function(a){this.x=a};JSBeams.Node.prototype.setY=function(a){this.y=a};JSBeams.Node.prototype.setZ=function(a){this.z=a};JSBeams.Node.prototype.translate=function(a,b,c){this.x+=a;this.y+=b;this.z+=c};JSBeams.Node.prototype.translateXZ=function(a,b){this.translate(a,0,b)};JSBeams.Node.prototype.translateYZ=function(a,b){this.translate(0,a,b)};JSBeams.Node.prototype.translateX=function(a){this.translate(a,0,0)};
JSBeams.Node.prototype.translateY=function(a){this.translate(0,a,0)};JSBeams.Node.prototype.translateZ=function(a){this.translate(0,0,a)};JSBeams.Node.prototype.sub=function(a){return new JSBeams.Node(this.x-a.x,this.y-a.y,this.z-a.z)};JSBeams.Node.prototype.add=function(a){return new JSBeams.Node(this.x+a.x,this.y+a.y,this.z+a.z)};JSBeams.Node.prototype.mulf=function(a){return new JSBeams.Node(a*this.x,a*this.y,a*this.z)};
JSBeams.Node.prototype.cross=function(a){return new JSBeams.Node(this.y*a.z-this.z*a.y,this.z*a.x-this.x*a.z,this.x*a.y-this.y*a.x)};JSBeams.Node.prototype.dot=function(a){return this.x*a.x+this.y*a.y+this.z*a.z};JSBeams.Node.prototype.squaredNorm=function(){return this.dot(this)};JSBeams.Node.prototype.norm=function(){return Math.sqrt(this.dot(this))};JSBeams.Node.create=function(a,b,c){return new JSBeams.Node(a,b,c)};
JSBeams.Beam2d=function(a,b,c){c=void 0===c?{}:c;this.node1=a||null;this.node2=b||null;this.type=c.type||JSBeams.CC;this.dofs=c.dofs||[0,1,2,3,4,5];this.ei=c.ei||1;this.ea=c.ea||1;this.fzloc=c.fzloc||0;this.fxloc=c.fxloc||0;this.mu=c.mu||1;this.dT=c.dT||0;this.dTh=c.dTh||0;this.alpha=c.alpha||1.2E-5;this.kbb=this.kba=this.kab=this.kaa=this.b=this.a=this.kloc=null;this.t=new JSMatrix.Matrix;this.tt=new JSMatrix.Matrix;this.mloc=new JSMatrix.Matrix;this.m=new JSMatrix.Matrix;this.load=JSMatrix.Vector.Zeros(6);
this.loadCC=JSMatrix.Vector.Zeros(6);this.dspl=JSMatrix.Vector.Zeros(6);this.eigShapes=[];this.cos=this.sin=this.len=null};JSBeams.Beam2d.prototype.setGeom=function(){var a=this.node2.x-this.node1.x,b=this.node2.z-this.node1.z;this.len=Math.sqrt(a*a+b*b);this.cos=a/this.len;this.sin=b/this.len};JSBeams.Beam2d.prototype.hasBodyLoad=function(){return this.fzloc||this.fxloc||this.dT||this.dTh};
JSBeams.Beam2d.prototype.setStiffAndTrsfMats=function(){var a=this.len,b=this.ea/a,c=this.ei/a,e=c/a,a=e/a,d=this.sin,f=this.cos;switch(this.type){case JSBeams.HC:this.t.fromArray([[f,d,0,0,0],[-d,f,0,0,0],[0,0,f,d,0],[0,0,-d,f,0],[0,0,0,0,1]]);this.tt.fromArray([[f,-d,0,0,0],[d,f,0,0,0],[0,0,f,-d,0],[0,0,d,f,0],[0,0,0,0,1]]);break;case JSBeams.CH:this.t.fromArray([[f,d,0,0,0],[-d,f,0,0,0],[0,0,1,0,0],[0,0,0,f,d],[0,0,0,-d,f]]);this.tt.fromArray([[f,-d,0,0,0],[d,f,0,0,0],[0,0,1,0,0],[0,0,0,f,-d],
[0,0,0,d,f]]);break;case JSBeams.HH:this.t.fromArray([[f,d,0,0],[-d,f,0,0],[0,0,f,d],[0,0,-d,f]]);this.tt.fromArray([[f,-d,0,0],[d,f,0,0],[0,0,f,-d],[0,0,d,f]]);break;default:this.t.fromArray([[f,d,0,0,0,0],[-d,f,0,0,0,0],[0,0,1,0,0,0],[0,0,0,f,d,0],[0,0,0,-d,f,0],[0,0,0,0,0,1]]),this.tt.fromArray([[f,-d,0,0,0,0],[d,f,0,0,0,0],[0,0,1,0,0,0],[0,0,0,f,-d,0],[0,0,0,d,f,0],[0,0,0,0,0,1]])}b=JSMatrix.Matrix.create([[b,0,0,-b,0,0],[0,12*a,-6*e,0,-12*a,-6*e],[0,-6*e,4*c,0,6*e,2*c],[-b,0,0,b,0,0],[0,-12*
a,6*e,0,12*a,6*e],[0,-6*e,2*c,0,6*e,4*c]]);if(this.type){switch(this.type){case JSBeams.HC:this.a=[0,1,3,4,5];this.b=[2];break;case JSBeams.CH:this.a=[0,1,2,3,4];this.b=[5];break;case JSBeams.HH:this.a=[0,1,3,4],this.b=[2,5]}this.kaa=b.getSubMatrix(this.a,this.a);this.kab=b.getSubMatrix(this.a,this.b);this.kba=b.getSubMatrix(this.b,this.a);this.kbbinv=b.getSubMatrix(this.b,this.b).inv();this.kloc=this.kaa.sub(this.kab.mulm(this.kbbinv).mulm(this.kba))}else this.kloc=b};
JSBeams.Beam2d.prototype.computeGlobStiffMatrix=function(){return this.tt.mulm(this.kloc).mulm(this.t)};JSBeams.Beam2d.prototype.setMassMats=function(){var a=this.len,b=this.mu*a/420;this.mloc.fromArray([[140*b,0,0,70*b,0,0],[0,156*b,-22*a*b,0,54*b,13*b*a],[0,-22*a*b,4*b*a*a,0,-13*b*a,-3*b*a*a],[70*b,0,0,140*b,0,0],[0,54*b,-13*b*a,0,156*b,22*b*a],[0,13*b*a,-3*b*a*a,0,22*b*a,4*b*a*a]])};
JSBeams.Beam2d.prototype.linearStaticPreproc=function(){this.setGeom();this.setStiffAndTrsfMats();this.load.zero();this.hasBodyLoad()&&(this.loadCC.fromArray([this.ea*this.alpha*this.dT-0.5*this.fxloc*this.len,-0.5*this.fzloc*this.len,this.fzloc*this.len*this.len/12+this.ei*this.alpha*this.dTh,-this.ea*this.alpha*this.dT-0.5*this.fxloc*this.len,-0.5*this.fzloc*this.len,-this.fzloc*this.len*this.len/12-this.ei*this.alpha*this.dTh]),this.type?(this.load.zero(),this.load.setSubVector(this.a,this.loadCC.getSubVector(this.a).sub(this.kab.mulm(this.kbbinv).mulv(this.loadCC.getSubVector(this.b))))):
this.load=this.loadCC)};JSBeams.Beam2d.prototype.linearStaticPostpro=function(a,b){a=this.t.mulv(a);this.type?(this.dspl.zero(),this.dspl.setSubVector(this.a,a),this.dspl.setSubVector(this.b,this.kbbinv.mulv(this.loadCC.getSubVector(this.b).add(this.kba.mulv(a))).negated()),this.load.zero(),this.load.setSubVector(this.a,this.kloc.mulv(a).add(this.loadCC.getSubVector(this.a).sub(this.kab.mulm(this.kbbinv).mulv(this.loadCC.getSubVector(this.b)))))):(this.dspl=a,this.load=this.kloc.mulv(this.dspl).add(this.loadCC))};
JSBeams.Beam2d.prototype.eigenvalueDynamicPreproc=function(){this.setGeom();this.setStiffAndTrsfMats();this.setMassMats()};JSBeams.Beam2d.prototype.eigenvalueDynamicPostpro=function(a,b){this.eigShapes[a]=this.tt.mulv(b)};JSBeams.Beam2d.prototype.giveMidDeflFromLoad=function(){return this.fzloc*this.len*this.len*this.len*this.len/(384*this.ei)};JSBeams.Beam2d.prototype.giveMidDeflFromDspl=function(){return 0.5*(this.dspl[1]+this.dspl[4])+this.len/8*(-this.dspl[2]+this.dspl[5])};
JSBeams.Beam2d.prototype.giveMidDefl=function(){return this.giveMidDeflFromDspl()+this.giveMidDeflFromLoad()};JSBeams.Beam2d.prototype.giveMidDeflOfEigShape=function(a){a=this.eigShapes[a];return 0.5*(a[1]+a[4])+this.len/8*(-a[2]+a[5])};JSBeams.Beam2d.prototype.giveMidMoment=function(){return-this.load[2]-0.5*this.load[1]*this.len-0.125*this.fzloc*this.len*this.len};JSBeams.Beam2d.create=function(a,b,c){a=new JSBeams.Beam2d(a,b,c);a.setGeom();return a};
JSBeams.LinearStaticSolver=function(a,b,c,e,d,f,g){this.beams=a;this.u=b;this.p=c;this.nDofs=this.u.length+this.p.length;this.nodalLoad=void 0===d?JSMatrix.Vector.Zeros(this.nDofs):d;this.withPrescribedDspl=void 0===f?!1:f;this.computeReactions=void 0===g?!1:g;this.k=JSMatrix.Matrix.Zeros(this.nDofs,this.nDofs);this.dspl=void 0===e?JSMatrix.Vector.Zeros(this.nDofs):e;this.beamLoad=JSMatrix.Vector.Zeros(this.nDofs);this.load=JSMatrix.Vector.Zeros(this.nDofs)};
JSBeams.LinearStaticSolver.prototype.assemble=function(){this.k.zero();for(var a=0;a<this.beams.length;a++){var b=this.beams[a],c=b.dofs;b.computeGlobStiffMatrix().assemble(this.k,c,c)}};
JSBeams.LinearStaticSolver.prototype.solve=function(){this.load=this.nodalLoad.add(this.beamLoad);var a=this.k.getSubMatrix(this.u,this.u),b=this.k.getSubMatrix(this.p,this.u),c=this.load.getSubVector(this.u);if(this.withPrescribedDspl){var e=this.k.getSubMatrix(this.u,this.p),d=this.k.getSubMatrix(this.p,this.p),f=this.dspl.getSubVector(this.p);this.dspl.setSubVector(this.u,a.linSolve(c.sub(e.mulv(f))));this.computeReactions&&(this.load.setSubVector(this.p,b.mulv(this.dspl.getSubVector(this.u)).add(d.mulv(f))),
this.load.isub(this.beamLoad))}else this.dspl.setSubVector(this.u,a.linSolve(c)),this.computeReactions&&(this.load.setSubVector(this.p,b.mulv(this.dspl.getSubVector(this.u))),this.load.isub(this.beamLoad))};JSBeams.LinearStaticSolver.prototype.preprocBeams=function(){this.beamLoad.zero();for(var a=0;a<this.beams.length;a++){var b=this.beams[a];b.linearStaticPreproc();b.type?this.beamLoad.decrSubVector(b.dofs,b.tt.mulv(b.load.getSubVector(b.a))):this.beamLoad.decrSubVector(b.dofs,b.tt.mulv(b.load))}};
JSBeams.LinearStaticSolver.prototype.updateBeams=function(){for(var a=0;a<this.beams.length;a++){var b=this.beams[a];b.linearStaticPostpro(this.dspl.getSubVector(b.dofs))}};JSBeams.LinearStaticSolver.prototype.update=function(a,b){b=void 0===b?!0:b;(void 0===a||a)&&this.preprocBeams();this.assemble();this.solve();b&&this.updateBeams()};JSBeams.LinearStaticSolver.create=function(a,b,c,e,d,f,g){return new JSBeams.LinearStaticSolver(a,b,c,e,d,f,g)};
JSBeams.EigenValueDynamicSolver=function(a,b,c,e,d){this.beams=a;this.u=b;this.p=c;this.nDofs=this.u.length+this.p.length;this.nEigModes=void 0===e?1:e;this.concMass=void 0===d?JSMatrix.Vector.Zeros(this.nDofs):d;this.k=JSMatrix.Matrix.Zeros(this.nDofs,this.nDofs);this.m=JSMatrix.Matrix.Zeros(this.nDofs,this.nDofs);this.eigFreqs=[];for(a=0;a<this.nEigModes;a++)this.eigFreqs[a]=0;this.eigShapes=[];for(a=0;a<this.nEigModes;a++)this.eigShapes[a]=JSMatrix.Vector.Zeros(this.nDofs)};
JSBeams.EigenValueDynamicSolver.prototype.assemble=function(){this.k.zero();this.m.zero();for(var a=0;a<this.beams.length;a++){var b=this.beams[a],c=b.dofs;b.computeGlobStiffMatrix().assemble(this.k,c,c);this.m.incrSubMatrix(c,c,b.m)}for(a=0;a<this.nDofs;a++)this.m[a][a]+=this.concMass[a]};
JSBeams.EigenValueDynamicSolver.prototype.solve=function(){for(var a=this.k.getSubMatrix(this.u,this.u),b=this.m.getSubMatrix(this.u,this.u),a=a.eigSymmetric({mat:b,nEigModes:this.nEigModes}),b=0;b<this.nEigModes;b++)this.eigFreqs[b]=a[0][b],this.eigShapes[b].setSubVector(this.u,a[1][b])};JSBeams.EigenValueDynamicSolver.prototype.preprocBeams=function(){for(var a=0;a<this.beams.length;a++)this.beams[a].eigenvalueDynamicPreproc()};
JSBeams.EigenValueDynamicSolver.prototype.updateBeams=function(){for(var a=0;a<this.nEigModes;a++)for(var b=0;b<this.beams.length;b++){var c=this.beams[b];c.eigenvalueDynamicPostpro(a,this.eigShapes[a].getSubVector(c.dofs))}};JSBeams.EigenValueDynamicSolver.prototype.update=function(a,b){b=void 0===b?!0:b;(void 0===a||a)&&this.preprocBeams();this.assemble();this.solve();b&&this.updateBeams()};
JSBeams.EigenValueDynamicSolver.create=function(a,b,c,e,d){return new JSBeams.EigenValueDynamicSolver(a,b,c,e,d)};JSBeams.CrossSection=function(a,b){this.nodes=a;this.nodes[this.nodes.length-1]!=this.nodes[0]&&this.nodes.push(this.nodes[0]);this.holes=b||[[]];this.core=this.beta=this.i2=this.i1=this.dyz=this.iz=this.iy=this.cz=this.cy=this.sz=this.sy=this.a=null};
JSBeams.CrossSection.prototype.reset=function(){this.core=this.convexHull=this.beta=this.i2=this.i1=this.dyz=this.iz=this.iy=this.cz=this.cy=this.sz=this.sy=this.a=null};JSBeams.CrossSection.prototype.computeA=function(){for(var a=0,b,c,e=0;e<this.nodes.length-1;e++)b=this.nodes[e],c=this.nodes[e+1],a+=b.y*c.z-c.y*b.z;return 0.5*a};
JSBeams.CrossSection.prototype.computeSy=function(a){var b=0;if(void 0===a?0:a){if(null===this.cz)return null;b=this.cz}a=0;for(var c,e,d,f,g=0;g<this.nodes.length-1;g++)c=this.nodes[g],e=this.nodes[g+1],d=c.y,f=e.y,c=c.z-b,e=e.z-b,a+=(e+c)*(d*e-f*c);return 1/6*a};
JSBeams.CrossSection.prototype.computeSz=function(a){var b=0;if(void 0===a?0:a){if(null===this.cy)return null;b=this.cy}a=0;for(var c,e,d,f,g=0;g<this.nodes.length-1;g++)c=this.nodes[g],e=this.nodes[g+1],d=c.y-b,f=e.y-b,c=c.z,e=e.z,a+=(d+f)*(d*e-f*c);return 1/6*a};JSBeams.CrossSection.prototype.computeCy=function(){var a=null===this.a?this.computeA():this.a;return(null===this.sz?this.computeSz():this.sz)/a};
JSBeams.CrossSection.prototype.computeCz=function(){var a=null===this.a?this.computeA():this.a;return(null===this.sy?this.computeSy():this.sy)/a};JSBeams.CrossSection.prototype.computeIy=function(a){var b=0;if(void 0===a||a){if(null===this.cz)return null;b=this.cz}a=0;for(var c,e,d,f,g=0;g<this.nodes.length-1;g++)c=this.nodes[g],e=this.nodes[g+1],d=c.y,f=e.y,c=c.z-b,e=e.z-b,a+=(c*c+c*e+e*e)*(d*e-f*c);return 1/12*a};
JSBeams.CrossSection.prototype.computeIz=function(a){var b=0;if(void 0===a||a){if(null===this.cy)return null;b=this.cy}a=0;for(var c,e,d,f,g=0;g<this.nodes.length-1;g++)c=this.nodes[g],e=this.nodes[g+1],d=c.y-b,f=e.y-b,c=c.z,e=e.z,a+=(d*d+d*f+f*f)*(d*e-f*c);return 1/12*a};
JSBeams.CrossSection.prototype.computeDyz=function(a){var b=0,c=0;if(void 0===a||a){if(null===this.cy)return null;b=this.cy;if(null===this.cz)return null;c=this.cz}a=0;for(var e,d,f,g,h=0;h<this.nodes.length-1;h++)e=this.nodes[h],d=this.nodes[h+1],f=e.y-b,g=d.y-b,e=e.z-c,d=d.z-c,a+=(f*d+2*f*e+2*g*d+g*e)*(f*d-g*e);return 1/24*a};JSBeams.CrossSection.prototype.computeI0=function(){var a=null===this.iy?this.computeIy():this.iy,b=null===this.iz?this.computeIz():this.iz;return a+b};
JSBeams.CrossSection.prototype.computeInertiaTensor=function(){var a=null===this.iy?this.computeIy():this.iy,b=null===this.iz?this.computeIz():this.iz,c=null===this.dyz?this.computeDyz():this.dyz;return[[a,-c],[-c,b]]};
JSBeams.CrossSection.prototype.computePrincipalValues=function(){var a=null===this.iy?this.computeIy():this.iy,b=null===this.iz?this.computeIz():this.iz,c=null===this.dyz?this.computeDyz():this.dyz;if(a===b)return[a,b,0];if(0===c)return a>b?[a,b,0]:[b,a,0.5*Math.PI];var e=0.5*Math.atan(2*c/(b-a)),d=Math.cos(e),f=Math.sin(e),g=d*d*a+f*f*b-2*d*f*c,a=f*f*a+d*d*b+2*d*f*c;return g>a?[g,a,e]:[a,g,e+0.5*Math.PI]};
JSBeams.CrossSection.prototype.computeStress=function(a,b,c,e,d,f){var g=null===this.a?this.computeA():this.a,h=null===this.iy?this.computeIy():this.iy,j=null===this.iz?this.computeIz():this.iz,k=null===this.dyz?this.computeDyz():this.dyz;f||(a-=null===this.cy?this.computeCy():this.cy,b-=null===this.cz?this.computeCz():this.cz);return c/g+(e*j+d*k)/(h*j-k*k)*b-(d*h+e*k)/(h*j-k*k)*a};JSBeams.CrossSection.prototype.computeStressInNode=function(a,b,c,e){return this.computeStress(a.y,a.z,b,c,e)};
JSBeams.CrossSection.prototype.computeNeutralAxis=function(a,b,c,e){var d=null===this.a?this.computeA():this.a,f=null===this.iy?this.computeIy():this.iy,g=null===this.iz?this.computeIz():this.iz,h=null===this.dyz?this.computeDyz():this.dyz,j=-(c*f+b*h)/(f*g-h*h);b=(b*g+c*h)/(f*g-h*h);a/=d;e&&(e=null===this.cy?this.computeCy():this.cy,d=null===this.cz?this.computeCz():this.cz,a+=j*e+b*d);return[j,b,a]};
JSBeams.CrossSection.prototype.giveConvexHull=function(){if(4>=this.nodes.length)return this.nodes.slice();for(var a=this.nodes[0],b=this.nodes[0],c=0,e=0,d=1;d<this.nodes.length;d++)this.nodes[d].z<a.z?(a=this.nodes[d],c=d):this.nodes[d].z>b.z?(b=this.nodes[d],e=d):(this.nodes[d].z===a.z&&this.nodes[d].y<a.y&&(a=this.nodes[d],c=d),this.nodes[d].z===b.z&&this.nodes[d].y>b.y&&(b=this.nodes[d],e=d));var d=this.nodes.slice(0,this.nodes.length-1),f=c<e?d.slice(c,e):d.slice(c).concat(d.slice(0,e)),c=e<
c?d.slice(e,c):d.slice(e).concat(d.slice(0,c));f.push(b);c.push(a);var g,h,j,k,l,m=f.length,n=c.length,p=[];j=0;if(2<m){do{p.push(f[j]);k=f[j];e=b.sub(k);h=1E20;for(d=j+1;d<m;d++)l=f[d].sub(k),g=l.dot(e)/(l.norm()*e.norm()),g<=h&&0<=l.cross(e).x&&(j=d,h=g)}while(j<m-1)}else p=[a];f=[];j=0;if(2<n){do{f.push(c[j]);k=c[j];e=a.sub(k);h=1E20;for(d=j+1;d<n;d++)l=c[d].sub(k),g=l.dot(e)/(l.norm()*e.norm()),g<=h&&0<=l.cross(e).x&&(j=d,h=g)}while(j<n-1)}else f=[b];return p.concat(f).concat(a)};
JSBeams.CrossSection.prototype.computeCore=function(a){for(var b=[],c=null===this.convexHull?this.giveConvexHull():this.convexHull,e=null===this.a?this.computeA():this.a,d=null===this.iy?this.computeIy():this.iy,f=null===this.iz?this.computeIz():this.iz,g=null===this.dyz?this.computeDyz():this.dyz,h=null===this.cy?this.computeCy():this.cy,j=null===this.cz?this.computeCz():this.cz,k,l,m,n,p,r,q=0;q<c.length-1;q++)m=c[q],k=c[q+1],l=m.y-h,n=k.y-h,m=m.z-j,p=k.z-j,r=e*(l*p-n*m),k=(g*(n-l)+f*(m-p))/r,l=
(g*(m-p)+d*(n-l))/r,b[q]=a?new JSBeams.Node(0,k,l):new JSBeams.Node(0,k+h,l+j);return b};JSBeams.CrossSection.prototype.update=function(){this.a=this.computeA();this.sy=this.computeSy();this.sz=this.computeSz();this.cy=this.computeCy();this.cz=this.computeCz();this.iy=this.computeIy();this.iz=this.computeIz();this.dyz=this.computeDyz();var a=this.computePrincipalValues();this.i1=a[0];this.i2=a[1];this.beta=a[2];this.convexHull=this.giveConvexHull();this.core=this.computeCore()};
JSBeams.CrossSection.create=function(a,b){return new JSBeams.CrossSection(a,b)};
